// nW̃pgbNXvCȐɂԃvO

#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <tchar.h>
#include "matrix.h"


class SPLINE_P{	//	ꎟ̃pgbNXvCȐNX
	friend class SPLINE_N;
	double* a;	//	ԂƂ̌W
	double* b;	//	ԂƂ̌W
	double* c;	//	ԂƂ̌W
	double* d;
	int nmax;
	int max;
public:
	SPLINE_P(){
		a=b=c=d=0;
		nmax=0;
		max=0;
	}
	SPLINE_P(int n){
		alloc(n);
	}
	~SPLINE_P(){
		delete [] a;
		delete [] b;
		delete [] c;
		delete [] d;
	}
	void alloc(int n){
		if(max<n){
			if(a){
				delete [] a;
				delete [] b;
				delete [] c;
				delete [] d;
			}
			a=new double[n-1];
			b=new double[n-1];
			c=new double[n-1];
			d=new double[n-1];
			nmax=n;
			max=n;
		}else{
			nmax=n;
		}
	}
	void put(int n){
		_tprintf(TEXT("%i,%g,%g,%g,%g\n"),n,a[n],b[n],c[n],d[n]);
	}
	void put(void){
		for(int n=0;n<nmax-1;n++){
			put(n);
		}
	}
	double interpolation(double x,int n){	//	w肵Ԃdx=x-xnɑ΂Ԓl
		return a[n]*x*x*x + b[n]*x*x + c[n]*x + d[n];
	}
};

// 1z2zƂăANZXNX

class DOUBLE_2VEC{
	double* p;
	int cram;
public:
	DOUBLE_2VEC(int n){
		cram=n;
	}
	double* operator=(double* x){
		return p=x;
	}
	double* operator[](int n){
		return p+n*cram;
	}
};


// nW̃pgbNXvCȐNX


class SPLINE_N{
public:
	SPLINE_P* spline_p;		//	pgbNXvCNX n
	int nmax;
	int dim;
	int	dmax;
	MATRIX g;
	MATRIX_OWN_COLUMN* k;
	MATRIX_OWN_COLUMN* s;
	SPLINE_N(){
		dmax=nmax=0;
		dim=0;
		spline_p=0;
	}
	SPLINE_N(int d,int n){	//	,m_
		dmax=nmax=0;
		dim=0;
		spline_p=0;
		alloc(d,n);
	}
	~SPLINE_N(){
		delete [] spline_p;
		delete [] s;
		delete [] k;
	}
	void alloc(int d,int n){
		if(dmax<d){
			if(spline_p){
				delete [] spline_p;
				delete [] k;
				delete [] s;
			}
			dmax=d;
		}
		nmax=n;
		dim=d;
		spline_p=new SPLINE_P[dmax];
		k=new MATRIX_OWN_COLUMN[dim];
		s=new MATRIX_OWN_COLUMN[dim];
		for(int i=0;i<dim;i++){
			spline_p[i].alloc(nmax);
		}
		g.alloc(nmax-3,nmax-3);
	}
	void put(int n){
		_tprintf(TEXT("%i\n"),n);
		for(int i=0;i<dim;i++){
			_tprintf(TEXT("\t"));
			spline_p[i].put(n);
		}
	}
	void put(void){
		for(int n=0;n<nmax-1;n++){
			put(n);
		}
	}
	void coefficient(double* pa){	// WꗗW̎ZsB
		DOUBLE_2VEC p(dim);	// 1z2zƂăANZXNX
		p=pa;
		int i;
		for(i=0;i<dim;i++){
			k[i].alloc(nmax-3);
			s[i].alloc(nmax-3);
		}
		for(i=1;i<nmax-2;i++){
			for(int j=0;j<dim;j++){
				k[j][i-1]=6*(p[i+1][j]-2*p[i][j]+p[i-1][j]); 
			}
		}
		g.zero();
		for(i=0;i<=nmax-4;i++){
			if(0<i)
				g[i][i-1]=1;
			g[i][i]=4;
			if(i<nmax-4)
				g[i][i+1]=1;
		}
		g.forward_sub(k,dim,false);	//	Oi
		g.backward_sub(k,s,dim);	//	ޑ
		double s0,s1;
		double ka,kb,kc,kd;
		for(int n=0;n<dim;n++){
			for(i=0;i<=nmax-2;i++){
				if(i==0){
					s0=0;
					s1=s[n][i];
				}else if(i==nmax-3){
					s0=s[n][i-1];
					s1=0;
				}else if(i==nmax-2){
					s0=0;
					s1=0;
				}else{
					s0=s[n][i-1];
					s1=s[n][i];
				}
				spline_p[n].a[i]=ka=(s1-s0)/6.0f;
				spline_p[n].b[i]=kb=s0/2.0f;
				spline_p[n].c[i]=kc=(p[i+1][n]-p[i][n])-1.0f/6.0f*(2.0f*s0+s1);
				spline_p[n].d[i]=kd=p[i][n];
			}
		}
	}
	void interpolation(double* p2,double* p1,int d){		// ԂdĕԒl̍Wꗗ쐬p1ɕۑ
		int i;
		int u=0;
		DOUBLE_2VEC pb(dim);	// 1z2zƂăANZXNX
		pb=p2;
		DOUBLE_2VEC p(dim);	// 1z2zƂăANZXNX
		p=p1;
		for(i=0;i<nmax-1;i++){
			double dx,x,y;
			dx=1.0f/double(d);
			for(int j=0;j<d;j++){
				for(int n=0;n<dim;n++){
					x=dx*double(j);
					y=spline_p[n].interpolation(x,i);
					p[u][n]=y;
				}
				++u;
			}
			for(int n=0;n<dim;n++){
				p[u][n]=pb[i+1][n];

			}
		}
	}
};



#define HMAX 4 //  Ԃ̕

//	͍W

#define NMAX2 6	//	̓f[^[
#define DIM 2 // W̎

double sp[][2]={{ 2041.68,	1575.59 },
				{ 2830.84,	2298.99 },
				{ 3685.07,	1900.71 },
				{ 4191.15,	1353.67 },
				{ 4889.14,	1648.74 },
				{ 5403.39,	2536.84 }};

	
double* p[NMAX2*HMAX][DIM]; // ԂꂽWۑ


void main(void){
	int i;

	SPLINE_N s;

	s.alloc(DIM,NMAX2);

	_tprintf(TEXT("input data\n"));
	_tprintf(TEXT("n,xn,yn\n"));

	for(i=0 ; i<NMAX2 ; i++){
		_tprintf(TEXT("%i"),i);
		for(int j=0;j<DIM;j++){
			_tprintf(TEXT(",%g"),sp[i][j]);
		}
		_tprintf(TEXT("\n"));
	}

	s.coefficient((double*)sp);
	_tprintf(TEXT("\ncoefficient\n"));
	_tprintf(TEXT("y=an*(t-tn)^3+bn*(t-tn)^2+cn*(t-tn)+dn\n"));
	_tprintf(TEXT("tn,an,bn,cn,dn\n"));
	s.put();
	s.interpolation((double*)sp,(double*)p,HMAX);
	_tprintf(TEXT("\ninterpolation\n"));
	_tprintf(TEXT("No,xn,yn\n"));
	for(i=0 ; i<(NMAX2-1)*HMAX+1 ; i++){
		_tprintf(TEXT("%i"),i);
		for(int j=0;j<DIM;j++){
			_tprintf(TEXT(",%g"),p[i][j]);
		}
		_tprintf(TEXT("\n"));
	}

}
